searchData={"items":[{"type":"module","title":"ExJsonLogger","ref":"ExJsonLogger.html","doc":"A Logger formatter that converts logs to single line JSON."},{"type":"module","title":"Logging additional information - ExJsonLogger","ref":"ExJsonLogger.html#module-logging-additional-information","doc":"Use Logger's metadata to add additional data to the log output.\nThis can be done through `Logger.metadata/1` or by passing Keywords to standard Logger calls in the optional second parameter.\nLogger filters metadata so any additional keys will need to be whitelisted in the backend's configuration."},{"type":"module","title":"Usage - ExJsonLogger","ref":"ExJsonLogger.html#module-usage","doc":"config :logger, :console,\n      format: {ExJsonLogger, :format},\n      metadata: [\n        :request_id,\n        :additional_key\n      ]\n\n*Currently tested with the `:console` logger backend.*"},{"type":"function","title":"ExJsonLogger.format/4","ref":"ExJsonLogger.html#format/4","doc":"Function referenced in the `:format` config."},{"type":"module","title":"ExJsonLogger.Ecto.Logger","ref":"ExJsonLogger.Ecto.Logger.html","doc":"An Ecto Logger replacement which captures and logs `Ecto.LogEntry` attributes through metadata.\n\nLogger Metadata available:\n * query - the query as string;\n * query_params - the query parameters as string;\n * query_time - the time spent executing the query in milliseconds;\n * decode_time - the time spent decoding the result in milliseconds;\n * queue_time - the time spent to check the connection out in milliseconds;\n\nMetadata is filtered by default so keys will need to be whitelisted."},{"type":"module","title":"Usage - ExJsonLogger.Ecto.Logger","ref":"ExJsonLogger.Ecto.Logger.html#module-usage","doc":"Add `ExJsonLogger.Ecto.Logger` to the Repo's configuration under the `:loggers` key.\n\n    config :sample, Sample.Repo,\n      adapter: Ecto.Adapters.MySQL,\n      username: \"root\",\n      password: \"\",\n      database: \"sample_dev\",\n      hostname: \"localhost\",\n      pool_size: 10,\n      loggers: [{ExJsonLogger.Ecto.Logger, :log, []}]"},{"type":"function","title":"ExJsonLogger.Ecto.Logger.log/2","ref":"ExJsonLogger.Ecto.Logger.html#log/2","doc":""},{"type":"module","title":"ExJsonLogger.Plug.Logger","ref":"ExJsonLogger.Plug.Logger.html","doc":"A plug for logging request information through metadata.\n\nLogger Metadata available:\n * method - request method\n * path - request path\n * status - request status (integer)\n * duration - time in milliseconds from connection to response (float)\n * format - (phoenix specific)\n * controller - (phoenix specific)\n * action - (phoenix specific)\n * query_string - raw unparsed request query string\n\nMetadata is filtered by default so keys will need to be whitelisted."},{"type":"module","title":"Usage - ExJsonLogger.Plug.Logger","ref":"ExJsonLogger.Plug.Logger.html#module-usage","doc":"To use with a Phoenix application, replace `plug Plug.Logger` in the projects endpoint.ex file with `ExJsonLogger.Plug.Logger`:\n\n    # plug Plug.Logger\n    plug ExJsonLogger.Plug.Logger"},{"type":"module","title":"Options - ExJsonLogger.Plug.Logger","ref":"ExJsonLogger.Plug.Logger.html#module-options","doc":"* `:log` - The log level at which this plug should log its request info.\nDefault is `:info`."},{"type":"function","title":"ExJsonLogger.Plug.Logger.call/2","ref":"ExJsonLogger.Plug.Logger.html#call/2","doc":""},{"type":"function","title":"ExJsonLogger.Plug.Logger.init/1","ref":"ExJsonLogger.Plug.Logger.html#init/1","doc":""},{"type":"extras","title":"License","ref":"license.html","doc":"# The MIT License (MIT)\n\nCopyright (c) 2017 RentPath\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE."},{"type":"extras","title":"Overview","ref":"readme.html","doc":"# ExJsonLogger\n\n[![Module Version](https://img.shields.io/hexpm/v/ex_json_logger.svg)](https://hex.pm/packages/ex_json_logger)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ex_json_logger/)\n[![Total Download](https://img.shields.io/hexpm/dt/ex_json_logger.svg)](https://hex.pm/packages/ex_json_logger)\n[![License](https://img.shields.io/hexpm/l/ex_json_logger.svg)](https://github.com/rentpath/ex_json_logger/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/rentpath/ex_json_logger.svg)](https://github.com/rentpath/ex_json_logger/commits/master)\n\nA drop-in replacement for `:console`'s formatter. ExJsonLogger takes standard `Logger` calls and JSON encodes them.\n\nEcto and Plug loggers are also included."},{"type":"extras","title":"Installation - Overview","ref":"readme.html#installation","doc":"The package can be installed by adding `:ex_json_logger` to your list of\ndependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_json_logger, \"~> 1.3.0\"}\n  ]\nend\n```\n\n```elixir\nconfig :logger, :console,\n  format: {ExJsonLogger, :format},\n  metadata: [\n    :action,\n    :controller,\n    :duration,\n    :format,\n    :method,\n    :path,\n    :request_id,\n    :status\n  ]\n```\n\nFor additional configuration and metadata option refer to `moduledocs`"},{"type":"extras","title":"Documentation - Overview","ref":"readme.html#documentation","doc":"Documentation is generated with [ExDoc](https://github.com/elixir-lang/ex_doc) and available online at [https://hexdocs.pm/ex_json_logger](https://hexdocs.pm/ex_json_logger)\n\n * Logger - *For more documentation reference `ExJsonLogger`*\n * Plug - *For more documentation reference `ExJsonLogger.Plug.Logger`*\n * Ecto - *For more documentation reference `ExJsonLogger.Ecto.Logger`*"},{"type":"extras","title":"Running the tests - Overview","ref":"readme.html#running-the-tests","doc":"Tests include:\n\n- Linter via [Credo](https://hex.pm/packages/credo)\n- Coverage via [Excoveralls](https://hex.pm/packages/excoveralls)\n- run tests: `script/test`\n- run tests with coverage: `script/test --coverage`"},{"type":"extras","title":"Running the benchmarks - Overview","ref":"readme.html#running-the-benchmarks","doc":"A basic benchee benchmarking script is available for testing performance\nimprovements:\n\n```bash\nmix run bench/format.exs\n```"},{"type":"extras","title":"Contributing - Overview","ref":"readme.html#contributing","doc":"-  If you modify code, add a corresponding test and documentation(if applicable).\n-  Create a Pull Request (please squash to one concise commit).\n-  Thanks!"},{"type":"extras","title":"Copyright and License - Overview","ref":"readme.html#copyright-and-license","doc":"Copyright (c) 2017 RentPath\n\nThis library licensed under the [MIT license](./LICENSE.md)."}],"content_type":"text/markdown"}